"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnoReactDraftjs = void 0;
var react_1 = __importStar(require("react"));
var draft_js_1 = require("draft-js");
var utils_1 = require("../utils");
var react_2 = require("@fluentui/react");
var uno_react_1 = require("uno-react");
var styles_1 = require("./styles");
exports.UnoReactDraftjs = react_1.forwardRef(function (_a, ref) {
    var markdown = _a.markdown, setMark = _a.setMark, placeholder = _a.placeholder, readonly = _a.readonly;
    var _b = react_1.useState(utils_1._convertFromMark(markdown)), editorState = _b[0], setEditor = _b[1];
    var _c = react_1.default.useState(true), hidden = _c[0], setHidden = _c[1];
    var editor = react_1.useRef(null);
    var _d = react_1.default.useState({
        bold: false,
        italic: false,
        underline: false,
    }), selected = _d[0], setSelected = _d[1];
    var focus = function () {
        var _a;
        (_a = editor.current) === null || _a === void 0 ? void 0 : _a.focus();
    };
    var applyInlineStyle = function (event, style) {
        var _a;
        event.preventDefault();
        setEditor(draft_js_1.RichUtils.toggleInlineStyle(editorState, style));
        setSelected(__assign(__assign({}, selected), (_a = {}, _a[style.toLowerCase()] = !selected[style.toLowerCase()], _a)));
    };
    var applyBlockType = function (event, style) {
        event.preventDefault();
        setEditor(draft_js_1.RichUtils.toggleBlockType(editorState, style));
    };
    var setText = function (newmark) {
        setEditor(utils_1._convertFromMark(newmark));
        setMark(newmark);
    };
    var updateMarkdownEffect = react_1.default.useCallback(function () {
        setMark(utils_1._convertToMark(editorState));
    }, [editorState]);
    uno_react_1.useEffectWithDebounce(updateMarkdownEffect, 200);
    react_1.useImperativeHandle(ref, function () { return ({
        setText: setText,
    }); });
    return (react_1.default.createElement("div", { onClick: focus, style: { border: '1px solid lightgray', minHeight: '80px', cursor: 'text' } },
        !hidden && (react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 8 }, styles: { root: { borderBottom: '1px solid lightgrey', marginBottom: '10px' } }, horizontal: true },
            react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Bold' }, title: 'Bold', ariaLabel: 'Bold', styles: styles_1.buttonStyles, onMouseDown: function (e) { return applyInlineStyle(e, 'BOLD'); }, checked: selected.bold }),
            react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Italic' }, title: 'Italic', ariaLabel: 'Italic', styles: styles_1.buttonStyles, onMouseDown: function (e) { return applyInlineStyle(e, 'ITALIC'); }, checked: selected.italic }),
            react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Underline' }, title: 'Underline', ariaLabel: 'Underline', styles: styles_1.buttonStyles, onMouseDown: function (e) { return applyInlineStyle(e, 'UNDERLINE'); }, checked: selected.underline }),
            react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'BulletedList' }, title: 'BulletedList', ariaLabel: 'BulletedList', styles: styles_1.buttonStyles, onMouseDown: function (e) { return applyBlockType(e, 'unordered-list-item'); } }))),
        react_1.default.createElement(draft_js_1.Editor, { ref: editor, onBlur: function () { return setHidden(true); }, onFocus: function () { return setHidden(false); }, editorState: editorState, onChange: setEditor, placeholder: placeholder, readOnly: readonly })));
});
