"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._convertToMark = exports._convertFromMark = void 0;
var markdown_draft_js_1 = require("markdown-draft-js");
var draft_js_1 = require("draft-js");
var options_1 = require("./options");
var _convertFromMark = function (markdown) {
    var raw = markdown_draft_js_1.markdownToDraft(markdown, options_1.fromMarkdownOptions);
    var content = draft_js_1.convertFromRaw(raw);
    return draft_js_1.EditorState.createWithContent(content);
};
exports._convertFromMark = _convertFromMark;
var _convertToMark = function (editor) {
    var content = editor.getCurrentContent();
    var raw = draft_js_1.convertToRaw(content);
    var mark = markdown_draft_js_1.draftToMarkdown(raw, options_1.toMarkdownOptions);
    return mark;
};
exports._convertToMark = _convertToMark;
